/* test the creation of Java arrays, ---rgf, 2003-02-17, 2003-05-10 */

   /* define the class objects (pre-registered by bsf4rexx) to test */
classes= 'Class.class' 'Object.class' 'Method.class' 'String.class' 'Array.class'    ,
         'boolean.class' 'Boolean.class' 'byte.class' 'Byte.class' 'char.class'      ,
         'Character.class' 'double.class' 'Double.class' 'float.class' 'Float.class' ,
         'int.class' 'Integer.class' 'long.class' 'Long.class' 'short.class'         ,
         'Short.class'

all=words(classes)   /* determine number of class objects   */
say "There are" all "class objects to test:"
say
crlf="0d0a"x
do i=1 to all
   dim=random(1,7)   /* number of dimensions */
   intArr=.bsf~createArray( 'int.class', dim)  /* create an int-array  */
   dimString=""
   count=1
   do dimIdx=1 to dim      -- ATTENTION: Object Rexx array semantics, indexing start with "1"
      nr=random(1,3)       /* determine number of elements in this dimension  */
      count=count*nr
      dimString=dimString || choose(dimIdx=1, "", ", ") || nr
      intArr[dimIdx]=nr
   end

   arr=.bsf~createArray( word(classes, i), intArr) /* now create the array */
   say "Created an array of type ["word(classes,i)"] dimensions=("||dimString")"
   say "        beanName="||arr
   say "      dimensions="||arr~dimension "(# of dimensions="||dim")"
   say "           items="||arr~items     "(count="count")"
   say copies("-", 50)
end
say "finished."
exit


choose: procedure /* Rexx-style of C/Java: "test ? then-value : else-value" */
  if arg(1)=1 then return arg(2)
              else return arg(3)

::requires BSF.CLS -- load the direct Object Rexx support for BSF4Rexx
